// Program do inteligentnego "klaskacza" AVT
// ATtiny13, fusebity oryginalne
// Micha Kurzela @ 2018

#include <avr/io.h>
#include <util/delay.h>

#define OUT_ON PORTB|=0b00000001
#define OUT_OFF PORTB&=0b11111110

#define WAIT_ON PORTB|=0b00000010
#define WAIT_OFF PORTB&=0b11111101

#define PULSE_1 bit_is_set(PINB,PINB2)
#define PULSE_0 bit_is_clear(PINB,PINB2)

#define OFF_ON PORTB|=0b00010000
#define OFF_OFF PORTB&=0b11101111

#define MNOZNIK_CZASU 2 //liczba ms odpowiadajca jednej dziace ADC

volatile uint16_t time; //tyle ms czekaj na drugie klanicie
volatile uint8_t stan_pk = 0; //0 wyczony, 1 zaczony

//=================================================
//=================================================
//=================================================

int main(void){

DDRB = (1 << DDB5) | (1 << DDB4) | (1 << DDB1) | (1 << DDB0); //konfiguracja we/wy
PORTB = (1 << PORTB5); //zawarto pocztkowa rejestru wyj 
ADMUX = (1 << MUX1) | (1 << MUX0); //wejcie ADC3, referencja z VCC
ADCSRA = (1 << ADEN) | (1 << ADSC) | (1 << ADATE); //preskaler przez 2, tryb Free Running

_delay_ms(100); //odczekaj 100ms na ustabilizowanie si toru m.cz.

while(1){

if(PULSE_1){ //jeeli nadszed impuls od mikrofonu
	time = (ADCL | (ADCH<<8)) * MNOZNIK_CZASU; //pobierz dugo odcinka czasu do odczekania
	
	while(PULSE_1); //czekaj, a impuls si zakoczy
	_delay_ms(20); //czekaj jeszcze 20ms - mogy przyj np. odbicia
	while(PULSE_1); //czekaj, a si zakoczy ewentualne odbicie

	WAIT_ON; //zacz diodk sygnalizujc oczekiwanie na drugie klanicie
	
	while(time > 0 && PULSE_0){ time--; _delay_ms(1); } //odliczaj czas do drugiego klanicia
	
	if(time == 0){ WAIT_OFF; } //czas przekroczony = zakoczenie oczekiwania
	if(time > 0){ WAIT_OFF; stan_pk ^= 1; } //czas nieprzekroczony = przecz wyjcie
	
	if(stan_pk == 0){OUT_OFF; OFF_ON;} else {OUT_ON; OFF_OFF;} //logika sterujca przekanikiem i diod OFF - wywoana natychmiast, aby wystapio przeczenie
	
	_delay_ms(50); //odczekaj po przeczeniu przekanika, aby nie odebra drugiego sygna

}

if(stan_pk == 0){OUT_OFF; OFF_ON;} else {OUT_ON; OFF_OFF;} //logika sterujca przekanikiem i diod OFF, powtarzana w ptli gwnej


}
}